
// C++20: variadic template + fold expression

#include <iostream>
#include <complex>

auto sum(auto && ... args) {    // template, universal reference
   return (0 + ... + args);     // fold needs ()
}

auto prod(auto && ... args) {
   return (1 * ... * args);
}

int main() {
   using namespace std::complex_literals;
   std::cout << sum(1, 2, 3, 4, 5) << "\n";
   std::cout << sum(1, 3.14, (1.0+1.0i)) << "\n";
   std::cout << prod(1, 2, 3, 4, 5) << "\n";
   std::cout << prod(1, 3.14, (1.0+1.0i)) << "\n";
}
