
#include <iostream>
#include <vector>
#include <set>
#include <list>
using namespace std;

template<typename Container>
void print(const Container &c) {
    for(auto x: c)
        cout << " " << x;
    cout << "\n";
}

int main() {
    vector<int> v { 1,2,3,4,5 };

    set<int>    s;      // empty set
    vector<int> v2;     // empty vector
    list<int>   l;      // empty list

    copy(begin(v),end(v), back_inserter(v2));   // uses push_back
    copy(begin(v),end(v), front_inserter(l));   //      push_front
    copy(begin(v),end(v), inserter(s,begin(s)));//      insert

    cout << "vector: ";
    print(v2);
    cout << "list:   ";
    print(l);
    cout << "set:    ";
    print(s);
}
