
// source: https://en.cppreference.com/w/cpp/utility/source_location
// __cpp_lib_source_location 201907L (C++20) Source-code information capture

#if 0
#ifndef __cpp_lib_source_location
#  error "Use C++20"
#endif
#endif

#include <iostream>
#include <source_location>
#include <string_view>

void log(const std::string_view message,
         const std::source_location location = std::source_location::current())
{
    std::clog << "file: "
              << location.file_name() << '('
              << location.line() << ':'
              << location.column() << ") `"
              << location.function_name() << "`: "
              << message << '\n';
}

template<typename T>
void fun(T x)
{
    log(x);
}

int main(int, char*[])
{
    log("Hello world!");
    fun("Hello C++20!");
}

