
// std::string example to demonstrate short string optimization
// public domain

#include <string>
#include <iostream>

int main() {
    std::string s1{"short string"};
    std::cout << "s1 == \"" << s1 << "\"\n";
    std::cout << "s1.size() == " << s1.size() << "\n";
    std::cout << "sizeof(s1) == " << sizeof(s1) << "\n";
    std::cout << "&s1 == " << &s1 << "\n";
    std::cout << "&s1[0] == " << static_cast<void*>(&s1[0]) << "\n";
    std::cout << "\n";
    s1="longer string of characters";
    std::cout << "s1 == \"" << s1 << "\"\n";
    std::cout << "s1.size() == " << s1.size() << "\n";
    std::cout << "&s1[0] == " << static_cast<void*>(&s1[0]) << "\n";
    std::cout << "\n";
    std::string s;      // we need other string TODO: reset allocation of s1
    std::cout << "s == \"" << s << "\"\n";
    std::cout << "s.capacity() == " << s.capacity() << "\n";
    void *ptr = static_cast<void*>(&s[0]);
    int optimization_limit = 0;
    for(int i=0; i<64; ++i) {
        s+='.';
        // std::cout << "&s[0] == " << static_cast<void*>(&s[0]) << "  " << s.size() << "\n";
        if(static_cast<void*>(&s[0]) != ptr) {
            optimization_limit = i;
            break;
        }
    }
    std::cout << "Short string optimization limit = " << optimization_limit << "\n";
    std::cout << "s == \"" << s << "\"\n";
    std::cout << "s.capacity() == " << s.capacity() << "\n";
    std::cout << "s.size() == " << s.size() << " == ";
    std::cout << "s.length() == " << s.length() << "\n";
    std::cout << "&s[0] == " << static_cast<void*>(&s[0]) << "\n";
    std::cout << "&s.c_str()[0] == " << static_cast<const void*>(&s.c_str()[0]) << "\n";
    std::cout << "\n";
}
