
// template parameter packs
// inspired by cppreference.com

#include <iostream>

template<typename... Ts>
void f(Ts... args)
{
    const int size = sizeof...(args) + 2;
    int res[size] = {10, args..., 20};

    // since initializer lists guarantee sequencing, this can be used to
    // call a function on each element of a pack, in order:
    int dummy[sizeof...(Ts)] = {(std::cout << args << '\n', 0)...};

    int sum=0;
    for(int x: res)
        sum+=x;
    std::cout << "sum=" << sum << "\n";
    std::cout << "n=" << sizeof...(Ts) << "\n";
    std::cout << "\n";
}

int main() {
    f(1,2,3);
    f('1',(short)2,3);  // try double (==narrowing error)
}

